<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>GTSBox: /Users/dlekshmi/Desktop/Repos/PhD/GTSBox/Projects/Transfection2018/UserFns/SSObjectiveFn.m Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">GTSBox
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_7a6499598ddcfcabe96e224cb4a6d834.html">Projects</a></li><li class="navelem"><a class="el" href="../../dir_947b0bade59f2ec1a3d6dcc5254e948b.html">Transfection2018</a></li><li class="navelem"><a class="el" href="../../dir_7a5ad7d5dca3599a31868c2bbca96b8c.html">UserFns</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">SSObjectiveFn.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../da/db2/_s_s_objective_fn_8m.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">function</span> [obj_fn]=<a class="code" href="../../da/db2/_s_s_objective_fn_8m.html#a5744ab977d588eacd0c8cf96c0be2a45">SSObjectiveFn</a>(parameters,invCi,Ci,Ai,singlecell_estimates,varargin)</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;SSobjOpts=varargin{1};</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;covariate_flag=SSobjOpts.covariate_flags;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;[betahat,D]=<a class="code" href="../../d8/d21/get_parameter_mat_fn_8m.html#affa4728eebf2bb9736f6b1ed97eb9afa">getParameterMatFn</a>(parameters);</div>
<div class="line"><a name="l00009"></a><span class="lineno"><a class="line" href="../../da/db2/_s_s_objective_fn_8m.html#a5744ab977d588eacd0c8cf96c0be2a45">    9</a></span>&#160;[p1]=cholcov(D(:,:,1));</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;[p2]=cholcov(D(:,:,2));</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keywordflow">if</span> ~any([isempty(p1),isempty(p2)])</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    N=length(singlecell_estimates);</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    % covariate_flags converted to dummy variable coding</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    ncov=length(unique(covariate_flag));</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    covariate_flags=<a class="code" href="../../d5/ddd/generate_dummy_var_8m.html#aa8b4264401f69256e730ceee4bcb7bb9">generateDummyVar</a>(covariate_flag,ncov);</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    ncells=length(invCi);</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    t1=0;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    t2=0;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordflow">for</span> i=1:ncells</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keywordflow">for</span> k=1:ncov</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;            % Note: The choice of modelling the covariance <span class="keyword">this</span> way is because</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;            % often we may want to impose some constraints on the covariance /</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;            % mean matrix. We could consider <span class="keyword">using</span> a matrix to left and right</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;            % multiply a D matrix as well. But currently <span class="keyword">this</span> is not</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;            % implemented.</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;            t1=t1+covariate_flags(i,k)*<a class="code" href="../../dd/d8f/logdet_8m.html#a7fde3a5a9071ae7308862255be416ac1">logdet</a>((Ci(:,:,i)+D(:,:,k)));</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            t2=t2+covariate_flags(i,k)*(singlecell_estimates(i,:)<span class="stringliteral">&#39;-...</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="stringliteral">                Ai(:,:,i)*betahat&#39;</span>)<span class="stringliteral">&#39;*getStableInverse(Ci(:,:,i)+...</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="stringliteral">                D(:,:,k))*(singlecell_estimates(i,:)&#39;</span>-Ai(:,:,i)*betahat<span class="stringliteral">&#39;);</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="stringliteral">        end</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="stringliteral">    end</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="stringliteral"></span> </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="stringliteral">    obj_fn=t1+t2;</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="stringliteral"></span> </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="stringliteral">    if ~isreal(obj_fn)</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="stringliteral">        obj_fn=10^10;</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="stringliteral">    else</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="stringliteral">        obj_fn=obj_fn;</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="stringliteral">    end</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="stringliteral">else</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="stringliteral">    obj_fn=10^10;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="stringliteral">end</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="stringliteral"></span> </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="stringliteral">end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="agenerate_dummy_var_8m_html_aa8b4264401f69256e730ceee4bcb7bb9"><div class="ttname"><a href="../../d5/ddd/generate_dummy_var_8m.html#aa8b4264401f69256e730ceee4bcb7bb9">generateDummyVar</a></div><div class="ttdeci">function generateDummyVar(in covariate_flag, in ncov)</div><div class="ttdoc">generateDummyVar generates dummy variable coding</div></div>
<div class="ttc" id="aget_parameter_mat_fn_8m_html_affa4728eebf2bb9736f6b1ed97eb9afa"><div class="ttname"><a href="../../d8/d21/get_parameter_mat_fn_8m.html#affa4728eebf2bb9736f6b1ed97eb9afa">getParameterMatFn</a></div><div class="ttdeci">function getParameterMatFn(in parameters, in varargin)</div><div class="ttdoc">Function that takes in a vector of parameters and converts it to.</div></div>
<div class="ttc" id="a_s_s_objective_fn_8m_html_a5744ab977d588eacd0c8cf96c0be2a45"><div class="ttname"><a href="../../da/db2/_s_s_objective_fn_8m.html#a5744ab977d588eacd0c8cf96c0be2a45">SSObjectiveFn</a></div><div class="ttdeci">function SSObjectiveFn(in parameters, in invCi, in Ci, in Ai, in singlecell_estimates, in varargin)</div><div class="ttdoc">SSObjectiveFn is a user specified objective which is specific to the project. This can be passed to t...</div></div>
<div class="ttc" id="alogdet_8m_html_a7fde3a5a9071ae7308862255be416ac1"><div class="ttname"><a href="../../dd/d8f/logdet_8m.html#a7fde3a5a9071ae7308862255be416ac1">logdet</a></div><div class="ttdeci">function logdet(in A, in op)</div><div class="ttdoc">Computes the log determininant, this code is taken from https://github.com/jluttine/matlab/blob/maste...</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Dec 3 2020 14:53:29 for GTSBox by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
